#!/bin/bash
set -e

# see man flock "EXAMPLES"
[ "${FLOCKER}" != "$0" ] && exec env FLOCKER="$0" flock -enF "$0" "$0" "$@" || :

BUFR_SH="$(dirname $0)/bufr.sh"
export BUFR_TABLES=/usr/share/metno-bufrtables/

########################################################################
# remove old bufr files
remove_old_bufr_files() {
    DD_BASE="$1"
    find "$DD_BASE" -type f -mtime "+14" -exec rm -vf \{\} \;
}

########################################################################
# find new bufr files since last run and concatenate into a single file
find_new_bufr_files() {
    WD_BASE="$1"
    IN_DIR="$2"
    IN_PAT="$3"

    # remember last script start time; we record the time before sorting to avoid
    # repeatedly processing the same files in case of an error
    TSFILE="$WD_BASE/lastrun.txt"
    if test -f "$TSFILE"; then
        NEWER="-newerct `cat $TSFILE`"
    fi
    date '+%Y-%m-%dT%H:%M:%S' > "${TSFILE}"

    find "$IN_DIR" -name "$IN_PAT" $NEWER -type f -exec cat '{}' + > "$WD_BASE/messages.bufr"
}

########################################################################
########################################################################
{% for bsg in bufr_sort_groups %}

# sort BUFR group with label {{ bsg.label }}

DATADIR_BASE={{ bsg.dataroot | quote }}
WORKDIR_BASE={{ bsg.workroot | quote }}
LOGDIR_BASE={{ bsg.logroot | quote  }}

mkdir -p "$DATADIR_BASE" "$WORKDIR_BASE" "$LOGDIR_BASE"

remove_old_bufr_files "$DATADIR_BASE"

find_new_bufr_files \
    "$WORKDIR_BASE" \
    {{ bsg.incoming_dir | quote }} \
    {{ bsg.incoming_pattern | quote }}

# sort bufr files by date and filter
{% for bf in bsg.filters %}
BUFR_TYPE={{ bf.name | quote }}
BUFR_DATA={{ bf.data | quote }}
"$BUFR_SH" \
    --type    "$BUFR_TYPE" \
    --ahl     {{ bf.filter | quote }} \
    --file    "$WORKDIR_BASE/messages.bufr" \
    --workdir "$WORKDIR_BASE/$BUFR_TYPE" \
    --datadir "$DATADIR_BASE/$BUFR_DATA" \
    --logdir  "$LOGDIR_BASE/$BUFR_TYPE" \
    || echo "ERROR processing BUFR messages for {{ bf.name }}"

{% endfor %}
{% endfor %}

{% if node_exporter_textfile_dir is defined %}
########################################################################
# generate metrics

find_newest_by_mtime() {
    DD_BASE="$1"
    NEWEST_MTIME=0
    while IFS= read -r -d $'\0' BUFR; do
        if test -r "$BUFR" ; then
            MTIME=`stat -c %Y "$BUFR"`
            if test "$MTIME" -gt "$NEWEST_MTIME" ; then
                NEWEST_MTIME="$MTIME"
            fi
        fi
    done < <(find "$DD_BASE" -type f -name "*.bufr" -print0)
    echo "$NEWEST_MTIME"
}

find_newest_by_name() {
    DD_BASE="$1"
    NEWEST_FILE=`find "$DD_BASE" -type f -name "*.bufr" | sort -r | head -n1`
    if test -r "$NEWEST_FILE" ; then
        NEWEST_NAME=`stat -c %Y "$NEWEST_FILE"`
    else
        NEWEST_NAME=0
    fi
    echo "$NEWEST_NAME"
}

PROMDIR={{ node_exporter_textfile_dir | quote }}
PROMFILE="$PROMDIR/devcoop_bufr_sort.prom"
PROMTMP="$PROMFILE.$$"

GAUGE_NAME="devcoop_bufr_sort_latest_name_timestamp"
GAUGE_MTIME="devcoop_bufr_sort_latest_mtime_timestamp"
cat <<EOF > "$PROMTMP"
# TYPE $GAUGE_NAME gauge
# UNIT $GAUGE_NAME seconds
# HELP $GAUGE_NAME Timestamp (seconds since epoch) of most BUFR file with latest date in filename
EOF

{% for bsg in bufr_sort_groups %}
NEWEST_NAME=`find_newest_by_name {{ bsg.dataroot | quote }}`
cat <<EOF >> "$PROMTMP"
$GAUGE_NAME{group="{{ bsg.label }}"} $NEWEST_NAME
EOF
{% endfor %}

cat <<EOF >> "$PROMTMP"
# TYPE $GAUGE_MTIME gauge
# UNIT $GAUGE_MTIME seconds
# HELP $GAUGE_MTIME Timestamp (seconds since epoch) of most recently modified BUFR file
EOF

{% for bsg in bufr_sort_groups %}
NEWEST_MTIME=`find_newest_by_mtime {{ bsg.dataroot | quote }}`
cat <<EOF >> "$PROMTMP"
$GAUGE_MTIME{group="{{ bsg.label }}"} $NEWEST_MTIME
EOF
{% endfor %}

mv "$PROMTMP" "$PROMFILE"

rm -f "$PROMDIR/devcoop_bufr_gts.prom" # remove prom file from old version of role "metno-decvoop-bufr-gts-sort"
{% endif %}
